Subject: Re: bug#31946: 27.0.50; The NSM should warn about more TLS problems

From: Eli Zaretskii <[email-masked]>
Date: Mon, 26 Aug 2019 21:12:53 +0300

> From: Andy Moreton <[email-masked]>
> Date: Mon, 26 Aug 2019 18:45:14 +0100
> 
> > That's because any memory allocated by GnuTLS cannot be freed by Emacs
> > via 'free' or 'xfree', it needs to be freed by calling 'gnutls_free'
> > (the GnuTLS manual clearly says that, btw).  That crashes, because on
> > Windows we use our own implementation of 'free', which uses a
> > different heap.
> 
> Agreed, but master built from commit 1071a4f still crashes in the same
> way:

Can you show a recipe?

> In Fgnutls_format_certificate, should out_buf be freed after calling
> build_string ?

I see no problem with that, since build_string copies the data.

> Removing both xfree(out.data) and xfree(out_buf) from the end of
> that function does give me a running emacs.

It may run, but it leaks memory.